/* Program pro demostraci metod rozpoznavani
 *   @author Ondrej Rohlik
 *   @version JDK 1.1
 */

import java.applet.*;
import java.awt.event.*;
import java.awt.*;
import java.lang.String;

/** Hlavni trida programu Digits
* @author Ondrej Rohlik
* @version JDK 1.1
*/
public class Digits extends java.applet.Applet /*implements Runnable*/ {

  static public int pocetEthalonu = 10;
  static public int pocetPriznaku = 7;
  static public Dimension velNastenky = new Dimension(260, 300);
  static public Color barvaPozadi = new Color(200, 160, 110);
  //static public Color barvaPozadi = new Color(255, 255, 255);
	public Object digits; /*SELF*/
  public Platno paintCanvas1;
  public Panel paintCanvas2, malyObrazek;
	public Zalozky zalozky;
  public Image	nastenka, button2Image, zalozkyImg;
  public Graphics deska,  button2g, zalozkyGr;
	public Panel pravy, levy, stredni, dolni; // pro Layout
  public ImageButton button1;
  public ImageButton button2;		//vse je public jen a jen kuli JWS 2.0 ne tak pro JDK
  public ImageButton button3;
  public ImageButton button4;
  public ImageButton button5;
  public TextField statusBar1;
  public Image imgUvod, imgMaly1, imgChBoxOn, imgChBoxOff;
	public Image img1On, img1Off, img2On, img2Off, img3On, img3Off, img4On, img4Off, img5On, img5Off;
  public AudioClip clipOK, clipBad, clipPip;
	public MediaTracker tracker;
        public Tracker      trackerThread;
	public Extrakce     extrakce;
	public Vzdalenosti  vzdalenosti;
	public Klasifikace  klasifikace;
  //public int dobaCekani[] = {500, 1000, 2000};
  public int dobaCekani[];
  public int pole[][];   		//hrana jednoho ctverecku = Platno.pocBodu
  public int polePriznaku[];		//pole priznaku
  public int poleVzdalenosti[];		//pole vzdalenosti od etalonu
  public int polePriznakuEthalonu[][];
  public String etaJmena[] = {"nula", "jedna", "dv\u011B", "t\u0159i", "\u010Dty\u0159i", "p\u011Bt", "\u0161est", "sedm", "osm", "dev\u011Bt"};
  public int symbPopisEthalonu[][] = {/*N,EN,ES, S,WS,WN, C*/ 
       				      {1, 1, 1, 1, 1, 1, 0}, //0
  /*	+---N---+	*/	      {0, 1, 1, 0, 0, 0, 0}, //1
  /*	|	      |	*/	      {1, 1, 0, 1, 1, 0, 1}, //2
  /*	WN	   EN */	      {1, 1, 1, 1, 0, 0, 1}, //3
  /*	|	      |	*/	      {0, 1, 1, 0, 0, 1, 1}, //4
  /*	+---C---+	*/	      {1, 0, 1, 1, 0, 1, 1}, //5
  /*	|	      |	*/	      {1, 0, 1, 1, 1, 1, 1}, //6
  /*	WS	   ES	*/	      {1, 1, 1, 0, 0, 0, 0}, //7
  /*	|	      |	*/	      {1, 1, 1, 1, 1, 1, 1}, //8
  /*	+---S---+	*/	      {1, 1, 1, 1, 0, 1, 1}, //9
  };  

/****************************************************************************/

  /**
  * metoda init() se vola, kdyz se applet nahraje a spusti.
  */
  public void init() {
		digits = this;
    pole = new int[Platno.sirka][Platno.vyska];
    polePriznakuEthalonu = new int[pocetEthalonu][pocetPriznaku];//getPriznakyEthalonu(symbPopisEthalonu);
    for (int i=0; i < pocetEthalonu; i++) 
      for (int j=0; j < pocetPriznaku; j++) 
				polePriznakuEthalonu[i][j] = symbPopisEthalonu[i][j]*3;
		dobaCekani = new int[3];
		setRychlost(false);

    clipOK = getAudioClip(getCodeBase(), "sound/ok.au");
    clipBad= getAudioClip(getCodeBase(), "sound/bad.au");
    clipPip= getAudioClip(getCodeBase(), "sound/pip.au");
    imgUvod = getImage(getCodeBase(), "img/Uvod.gif");
    imgMaly1 = getImage(getCodeBase(), "img/Maly1.gif");
    imgChBoxOn	= getImage(getCodeBase(), "img/ChBoxOn.gif");
    imgChBoxOff	= getImage(getCodeBase(), "img/ChBoxOff.gif");
    img1On	= getImage(getCodeBase(), "img/tl/1On.gif");
    img1Off	= getImage(getCodeBase(), "img/tl/1Off.gif");
    img2On	= getImage(getCodeBase(), "img/tl/2On.gif");
    img2Off	= getImage(getCodeBase(), "img/tl/2Off.gif");
    img3On	= getImage(getCodeBase(), "img/tl/3On.gif");
    img3Off	= getImage(getCodeBase(), "img/tl/3Off.gif");
    img4On	= getImage(getCodeBase(), "img/tl/4On.gif");
    img4Off	= getImage(getCodeBase(), "img/tl/4Off.gif");
    img5On	= getImage(getCodeBase(), "img/tl/5On.gif");
    img5Off	= getImage(getCodeBase(), "img/tl/5Off.gif");
    tracker = new MediaTracker(this); 
    tracker.addImage(imgUvod, 0);
    tracker.addImage(imgMaly1, 0);
    tracker.addImage(imgChBoxOn, 0);
    tracker.addImage(imgChBoxOff, 0);
    tracker.addImage(img1On, 0);
    tracker.addImage(img1Off, 0);
    tracker.addImage(img2On, 0);
    tracker.addImage(img2Off, 0);
    tracker.addImage(img3On, 0);
    tracker.addImage(img3Off, 0);
    tracker.addImage(img4On, 0);
    tracker.addImage(img4Off, 0);
    tracker.addImage(img5On, 0);
    tracker.addImage(img5Off, 0);
    trackerThread = new Tracker(this);
    trackerThread.start();

////////////////////////////////////////////////////////////
//levy.getGraphics().drawImage(imgMaly1, 0, 245, levy);
//levy.repaint();			
////////////////////////////////////////////////////////////
								
		/*
    deska.drawImage(img2, 0, 0, paintCanvas2);  // timhle se obrazek natahne
    deska.drawImage(img1, 0, 0, paintCanvas2);	// a pri ostrem vykresleni se
    deska.drawImage(img3, 0, 0, paintCanvas2);	// a pri ostrem vykresleni se
    deska.setColor(barvaPozadi);
    deska.fillRect(0, 0, 260, 300);
		*/	
						
									  		
    // Inicializace vsech komponent
    pravy	  = new Panel();  
    levy	  = new Panel();
    stredni = new Panel();
    dolni	  = new Panel();

    paintCanvas1 = new Platno(this); 
    paintCanvas1.setSize(Platno.sirkaPlatna, Platno.vyskaPlatna);
		
    zalozky = new Zalozky(this);
    zalozkyImg = createImage(165, 65);
    zalozkyGr = zalozkyImg.getGraphics();
    zalozkyGr.setColor(barvaPozadi);
		zalozkyGr.fillRect(0, 0, 165, 65);
    zalozkyGr.setColor(Color.black);
		zalozkyGr.drawRect(0, 0, 164, 64);
		zalozkyGr.setFont(new Font("Helvetica", Font.BOLD, 14));
		zalozkyGr.drawString("Rychlost v\u00FDpo\u010Dtu", 5, 20);
		zalozkyGr.drawString("Pomalu", 25, 37);
		zalozkyGr.drawString("Rychle", 25, 57);
    zalozky.setBackground(barvaPozadi);
    zalozky.repaint();

		
    paintCanvas2 = new Panel() {
      public Dimension	getPreferredSize() { return new Dimension(260, 300); }
      public void	update(Graphics g) { paint(g); }
      public void	paint( Graphics g) { 
	if (nastenka == null) {
	  nastenka = createImage(260, 300);
	  deska = nastenka.getGraphics();
	  clipBad.play();
	}
	g.drawImage(nastenka, 0, 0, this);
	//clipPip.play();
      }
    }; 
    nastenka = createImage(260, 300);
    deska = nastenka.getGraphics();
    deska.setColor(barvaPozadi);      //smazani nobo-li prebarveni na barvu pozadi
    deska.fillRect(0, 0, 260, 300);   //DOLE se to opakuje -> spravit
//    button2Image = createImage(260, 300);
//    button2g = button2Image.getGraphics();
    
    paintCanvas2.setBackground(barvaPozadi);
    paintCanvas2.repaint();

    statusBar1 = new TextField("Nakreslete my\u0161\u00ED segmentovou \u010D\u00EDslici, jak ji zn\u00E1te z LED displej\u016F") {
      public Dimension getPreferredSize() { return new Dimension(600, 20); }
    }; 
    statusBar1.setEditable(true);
    statusBar1.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	char c =' ';
	if (statusBar1.getText().toUpperCase().compareTo("NOWAIT")==0) {
	  dobaCekani[0] = 1; dobaCekani[1] = 1; dobaCekani[2] = 1; }
	if (statusBar1.getText().toUpperCase().compareTo("WAIT")==0) {
	  dobaCekani[0] = 500; dobaCekani[1] = 1000; dobaCekani[2] = 2000; }
	if (statusBar1.getText().toUpperCase().compareTo("BROWN")==0) {
	  button1.setBackground(new Color(100, 50, 0));  
	  button2.setBackground(new Color(100, 50, 0));  
	  button3.setBackground(new Color(100, 50, 0));  
	  button4.setBackground(new Color(100, 50, 0));  
	  button5.setBackground(new Color(100, 50, 0));  
	}
	//if (statusBar1.getText().toUpperCase().compareTo("PICTURE")==0) {
	//  button2.setBackground(new Color(100, 50, 0));  }
	try {  
	c = statusBar1.getText().charAt(0);
	} catch (IndexOutOfBoundsException eioob) {
	  statusBar1.setText("Prazdna prikazova radka !"); }
	if ((c>='0')&&(c<='3')) {
	  dobaCekani[(c-'0')] *= 2;  // cekaj 2krat tak dlouho
	}
	statusBar1.setText(c+" ... Hodnoty DELAYu jsou: "+dobaCekani[0]+", "+dobaCekani[1]+", "+dobaCekani[2]);
    }});  
//    button1 = new Button("Zobraz etalon '0'") {
//      public Dimension getPreferredSize() { return new Dimension(120, 52); }
//    };
		button1 = new ImageButton(img1Off, img1On, "Zobraz etalon '0'");

		button1.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {

	
			
        int kteryEthalon;
				zastavVlakna();
        showStatus("Zobrazuji etalony ...");
  	kteryEthalon = button1.getLabel().charAt(button1.getLabel().length()-2) - '0';
  	statusBar1.setText("Etalon " + etaJmena[kteryEthalon]);
  	//zobrazVzor(Color.lightGray, 8);
  	zobrazVzor(Color.black, kteryEthalon);
  	//kteryEthalon = (kteryEthalon+1)%10;
  	//button1.setLabel("Zobraz etalon '"+Integer.toString(kteryEthalon)+"'");
  	statusBar1.setText("Etalon "+etaJmena[kteryEthalon]+" ma p\u0159\u00EDznakov\u00FD vektor: ["+
	polePriznakuEthalonu[kteryEthalon][0]+", "+polePriznakuEthalonu[kteryEthalon][1]+", "+polePriznakuEthalonu[kteryEthalon][2]+", "+
	polePriznakuEthalonu[kteryEthalon][3]+", "+polePriznakuEthalonu[kteryEthalon][4]+", "+polePriznakuEthalonu[kteryEthalon][5]+", "+
	polePriznakuEthalonu[kteryEthalon][6]+", "+"]");
	
 	kteryEthalon = (kteryEthalon+1)%10;
  	button1.setLabel("Zobraz etalon '"+Integer.toString(kteryEthalon)+"'");
    }});
		
		
//    button2 = new Button("Sma\u017E") {
//      public Dimension getPreferredSize() { return new Dimension(120, 52); }
		button2 = new ImageButton(img2Off, img2On, "Sma\u017E");
    button2.addActionListener(paintCanvas1);	// registrace platna jako prijemce udalosti pri stisku tlacitka
    button2.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
				zastavVlakna();
        showStatus("Naposledy stisknuto tla\u010D\u00EDtko 'Sma\u017E'");
        statusBar1.setText("Nakreslete my\u0161\u00ED segmentovou \u010D\u00EDslici, jak ji zn\u00E1te z LED displej\u016F");
    }});
//    button3 = new Button("Extrahuj p\u0159\u00EDznaky") {
//      public Dimension getPreferredSize() { return new Dimension(120, 52); }
//    };
		button3 = new ImageButton(img3Off, img3On, "Extrahuj p\u0159\u00EDznaky");
		button3.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        //showStatus("Naposledy stisknuto tlacitko 'Ex P\u0159\u00EDzn'");
        //statusBar1.setText("");
				//polePriznaku = getPriznaky(pole, true);
				zastavVlakna();
        pole = paintCanvas1.doPole();
		    extrakce = new Extrakce((Digits)digits);
		    extrakce.start();

    }});
//    button4 = new Button("Spo\u010Dti vzd\u00E1lenosti") {
//      public Dimension getPreferredSize() { return new Dimension(120, 52); }
//    };
		button4 = new ImageButton(img4Off, img4On, "Spo\u010Dti vzd\u00E1lenosti");
    button4.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
      //if (polePriznaku==null)
      //  showStatus("Nejprve je t\u0159eba z\u00EDskat p\u0159\u00EDznaky, pak teprve lze po\u010Ditat vzd\u00E1lenosti");
      //else {
				zastavVlakna();
				pole = paintCanvas1.doPole();
		    vzdalenosti = new Vzdalenosti((Digits)digits);
		    vzdalenosti.start();
        //poleVzdalenosti = getVzdalenosti(polePriznaku);
        showStatus("Vektor vzd\u00E1lenost\u00ED od etalon\u016F je hotov.");
    	//}
    }});
//    button5 = new Button("Klasifikuj") {
//      public Dimension getPreferredSize() { return new Dimension(120, 52); }
//    };
		button5 = new ImageButton(img5Off, img5On, "Klasifikuj");
    button5.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent e) {
      //pole = paintCanvas1.doPole();
			//if (poleVzdalenosti==null)
			//  showStatus("Nejprve je t\u0159eba z\u00EDskat vektor vzd\u00E1lenost\u00ED a teprve potom lze klasifikovat");
			//else {
				zastavVlakna();
				pole = paintCanvas1.doPole();
		    klasifikace = new Klasifikace((Digits)digits);
		    klasifikace.start();
        //int trida = getMinimum(poleVzdalenosti);
        //showStatus("Tento obr\u00E1zek je za\u0159azen do t\u0159\u00EDdy: "+etaJmena[trida]);
			//}
		}});
   

    //pravy	  = new Panel();       //jsou inicializovany nahore
    //levy	  = new Panel();
    //stredni = new Panel();
    //dolni	  = new Panel();
    stredni.setLayout(new FlowLayout(FlowLayout.LEFT,10,10));// {
    //stredni.setBackground(Color.blue);
    stredni.add(button1);
    stredni.add(button2);
    stredni.add(button3);
    stredni.add(button4);
    stredni.add(button5);
		stredni.add(zalozky);
    levy.setLayout(new FlowLayout(FlowLayout.CENTER,  10, 10));
		//levy.setBackground(Color.green);
    levy.add(paintCanvas1);
    //levy.setBackground(Color.blue);
    pravy.setLayout(new FlowLayout(FlowLayout.LEFT, 10, 10));
    pravy.add(paintCanvas2);
    //pravy.setBackground(Color.green);
    dolni.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));
    dolni.add(statusBar1);
    //dolni.setBackground(Color.yellow);
    setLayout(new BorderLayout(0, 0));
    setBackground(barvaPozadi);
    add(levy,	 "West");
    add(stredni, "Center");
    add(pravy,	 "East");
    add(dolni,	 "South");
  }
  
  public boolean checkMustr(int i, int j) {
    boolean sedy = false;
    if ((i==1)||(i==7)) 
      if ((j!=0)&&(j!=14))
	sedy = true;
    if ((j==1)||(j==7)||(j==13)) 
      if ((i!=0)&&(i!=8))
	sedy = true;
    return sedy;
  }

  public void zastavVlakna() {
		if (extrakce!=null) { //tj. bezi
			extrakce.stop();
		}
		if (vzdalenosti!=null) { //tj. bezi
			vzdalenosti.stop();
		}
		if (klasifikace!=null) { //tj. bezi
			klasifikace.stop();
		}
	}	
	
	public void setRychlost (boolean r) {
		if (r) {
		  dobaCekani[0] = 0; dobaCekani[1] = 0; dobaCekani[2] = 0; }
		else {
		  dobaCekani[0] = 500; dobaCekani[1] = 1000; dobaCekani[2] = 2000;}
	}
	
  /**
  * metoda zobrazPole() se vola, po kazde uprave obrazku metodami 
  * predzpracovani, aby se provedene zmeny promitly z pameti na 
  * monitor
  */
  private void zobrazPole(int p[][], Color c, boolean vykreslovatPoJednom) {
    int i, j;
    for (i = 0; i< Platno.sirka; i++ ) 
      for (j = 0; j< Platno.vyska; j++ ) {
        if (p[i][j] == 1)
	  paintCanvas1.kresliCtverec(i, j, c, true, vykreslovatPoJednom);
        else
	  if (checkMustr(i, j))
	    paintCanvas1.kresliCtverec(i, j, Color.lightGray, true, vykreslovatPoJednom);
	  else
	    paintCanvas1.kresliCtverec(i, j, Color.white, true, vykreslovatPoJednom);
    }//for
  }//zobrazPole
  
  /**
  * metoda zobrazVzor() se vola jako obsluha a na vykresleni mustru
  */
  public void zobrazVzor(Color barva, int cislo) {
    int i, j, p[][] = new int[Platno.sirka][Platno.vyska];
    for (i = 0; i < Platno.sirka; i++) for (j = 0; j < Platno.vyska; j++) p[i][j]=0;
    for (i = 0; i < pocetPriznaku; i++ )  // i = kolikaty priznak
        if (symbPopisEthalonu[cislo][i]==1) // je-li tam cara nakresli ji
  	switch (i) {
  	  case 0: for (j = 1; j < 8; j++ ) p[j][1]  = 1; break;
  	  case 1: for (j = 1; j < 8; j++ ) p[7][j]  = 1; break;
  	  case 2: for (j = 1; j < 8; j++ ) p[7][j+6]= 1; break;
  	  case 3: for (j = 1; j < 8; j++ ) p[j][13] = 1; break;
  	  case 4: for (j = 1; j < 8; j++ ) p[1][j+6]= 1; break;
  	  case 5: for (j = 1; j < 8; j++ ) p[1][j]  = 1; break;
  	  case 6: for (j = 1; j < 8; j++ ) p[j][7]  = 1; break;
    	}//switch		    
    zobrazPole(p, barva, false);
    paintCanvas1.repaint();// pri mazani se to zavola dvakrt (PLYTVANI CASEM)
  }//zobrazVzor

  /**
  * metoda getSouradnice() je pouze pomocna pro <i>getParamtery</I>
  */
  private int[] getSouradnice(int priznak, int i, int j) {
    int x_smer=0, y_smer=0, x_start=0, y_start=0;
    boolean vodorovne = true;
    int back[] = new int[2];
    switch (priznak) {    // Kde zacit vykreslovat cervene ctverecky a kterym smerem ...
      case 0: vodorovne =  true; x_smer = 1; y_smer = 1; x_start = 3; y_start = 0; break;
      case 1: vodorovne = false; x_smer =-1; y_smer = 1; x_start = 8; y_start = 3; break;
      case 2: vodorovne = false; x_smer =-1; y_smer = 1; x_start = 8; y_start = 9; break;
      case 3: vodorovne =  true; x_smer =-1; y_smer =-1; x_start = 5; y_start =14; break;
      case 4: vodorovne = false; x_smer = 1; y_smer =-1; x_start = 0; y_start =11; break;
      case 5: vodorovne = false; x_smer = 1; y_smer =-1; x_start = 0; y_start = 5; break;
      case 6: vodorovne =  true; x_smer = 1; y_smer = 1; x_start = 3; y_start = 6; break;
    }//switch
    if (vodorovne) { 
    back[0] = x_start + x_smer*i;	  back[1] = y_start + y_smer*j;
    } else {
      back[0] = x_start + x_smer*j;	  back[1] = y_start + y_smer*i; // zrcadlove ...
    }
    return back;
  }

  /**
  * metoda getPriznaky() z objektu ziska vektor priznaku pomoci
  * metody obrysu
  * @param int p[][] ... ukazatel na pole z nehoz se maji priznaky spocitat
  * @return int p[][] ... ukazatel na vektor priznaku
  */
  public int[] getPriznaky(int p[][], boolean zobrazovat) {
    int	    priznak, i, j;	      // pom. prom. for cyklu
    int	    pp[] = new int[pocetPriznaku]; //pp jako polePriznaku
    int	    souradniceXY[] = new int[2];
    int	    x=0, y=0; //, x_smer=0, y_smer=0, x_start=0, y_start=0;
    boolean vodorovne = true, bylUzZapocitan = false;
    Font    fontNormal= new Font("Helvetica", Font.BOLD, 14),
	    fontBig   = new Font("Helvetica", Font.BOLD, 18),
	    fontGigant= new Font("Helvetica", Font.BOLD, 24),
	    fontSmall = new Font("Helvetica", Font.BOLD, 10);

	if (zobrazovat) {
    deska.setColor(barvaPozadi);
    deska.fillRect(0, 0, 260, 300);
    //deska.drawImage(img1, 0, 0, paintCanvas2);
    deska.setColor(new Color(0, 100, 0));
    deska.setFont(fontGigant);
    deska.drawString("EXTRAKCE P\u0158\u00CDZNAK\u016E", 0, 26);
    deska.setFont(fontNormal);
    deska.setColor(Color.black);
    deska.drawString("Pro ka\u017Ed\u00FD segment \u010Dislice zji\u0161\u0165ujeme,",0, 50);
    deska.drawString("kolik sloupc\u016F segment p\u0159ekr\u00FDv\u00E1.",0, 68);
    //deska.drawString("pocet sloupcu, ktere segment prekryva",0, 65);
    deska.setColor(Color.darkGray);
    deska.setFont(fontSmall);
    deska.drawString("segment",0, 86);
    deska.drawString("\u010Dislo",10, 100);
    for (i=0; i<3; i++) {
        deska.drawString("p\u0159ekryv",53+i*(56), 86);
        deska.drawString((i+1)+". trojice",48+i*57, 100);
    }	
    deska.drawString("hodnota",217, 86);
    deska.drawString("p\u0159\u00EDznaku",215, 100);
    deska.setFont(fontNormal);
    paintCanvas2.update(paintCanvas2.getGraphics());
    try {  Thread.sleep(dobaCekani[2]);   
    } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
	}//if_zobrazovat	
    for (priznak = 0; priznak < pocetPriznaku; priznak++) {
      //deska.drawString("priznak, 0, 75+20+priznak*25-3);
	 	 if (zobrazovat) {
			deska.setColor(Color.darkGray);
      deska.setFont(fontNormal);
      deska.drawString((priznak+1)+"", 17, 100+20+priznak*20);
      //deska.drawString((priznak+1)+"p\u0159\u00EDznak...", 10, 100+20+priznak*20);
		 }//if_zobrazovat	
      for (i=0; i < 3; i++) {
				bylUzZapocitan = false;
        for(j=0; j < 3; j++) {
			 	  souradniceXY = getSouradnice(priznak, i, j);
				  x = souradniceXY[0];
				  y = souradniceXY[1];
			 	  //	  x = getSouradnice(priznak, i, j)[0];
				  //	  y = getSouradnice(priznak, i, j)[1];
					//	  if (p[getSouradnice(priznak, i, j)[0]][getSouradnice(priznak, i, j)[1]] == 1) {  // if je bod cerne vybarveny
				  if (p[souradniceXY[0]][souradniceXY[1]] == 1) {  // if je bod cerne vybarveny
				    if (!bylUzZapocitan) {
				      pp[priznak]++;
				      bylUzZapocitan = true;
				    }
				    if (zobrazovat) 
							paintCanvas1.kresliCtverec(x, y, Color.red, true, true);
					  } else { 
					    if (zobrazovat)
							  paintCanvas1.kresliCtverec(x, y, Color.red, false, true);
					 	  }  
				  	  if (zobrazovat) {
								statusBar1.setText("\u010Ctverecek [" +x+ "], [" +y+ "]");
						  	try {
							  	Thread.sleep((int)(dobaCekani[0]/(priznak+1)));/*-*/
					 	  	} catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
						 	}
						}//forj
						if (zobrazovat) {
							if (bylUzZapocitan) {
								deska.setColor(Color.red);
							  deska.drawString("ANO", 55+i*57, 100+20+priznak*20);
					 		} else {
								deska.setColor(Color.blue);	
				 				deska.drawString("NE", 55+i*57+5, 100+20+priznak*20);
					 		}
							paintCanvas2.update(paintCanvas2.getGraphics()); 
					    try {
								Thread.sleep((int)(dobaCekani[0]/(priznak+1)));/*-*/
							} catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
						}//if_zobrazovat
		      }//fori
		      // a zase zpet na puvodni barvu (to policko 3x3 ctverectku):
					if (zobrazovat) {
			      for (i=0; i < 3; i++) 
				      for(j=0; j < 3; j++) {
							  souradniceXY = getSouradnice(priznak, i, j);
							  x = souradniceXY[0];
							  y = souradniceXY[1];
							  if (p[x][y]==1)
							    paintCanvas1.kresliCtverec(x, y, Color.black, true, true);
							  else 
							    if (checkMustr(x, y))
								    paintCanvas1.kresliCtverec(x, y, Color.lightGray, true, true);
								  else
								    paintCanvas1.kresliCtverec(x, y, Color.white, true, true);
						      }//for i,j (mazani)
					      deska.setColor(Color.black);
					      deska.setFont(fontBig);
					      deska.drawString(""+pp[priznak]+"", 230, 100+20+priznak*20+1);
						    paintCanvas2.update(paintCanvas2.getGraphics());
				 				clipPip.play();      
				 	      try {
				 		      Thread.sleep((int)(dobaCekani[1]/(priznak+1)));   
				 	      } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
							}//if_zobrazovat	
				    }//forpriznak
						if (zobrazovat) {
	    deska.setColor(Color.black);
		  deska.drawLine(10, 252, 250, 252);
			deska.setFont(fontNormal);
	    deska.drawString("p\u0159\u00EDznakov\u00FD vektor tedy vypad\u00E1...", 16, 270);
		  deska.setFont(fontBig);
	    deska.drawString("["+pp[0]+", "+pp[1]+", "+pp[2]+", "+pp[3]+", "+pp[4]+
			    ", "+pp[5]+", "+pp[6]+"]", 50, 295);
			paintCanvas2.update(paintCanvas2.getGraphics());
	    statusBar1.setText("Vektor P\u0159\u00EDznak\u016F: ["+pp[0]+","+pp[1]+","+
				  pp[2]+","+pp[3]+","+pp[4]+","+pp[5]+","+pp[6]+"]");
			//deska.setColor(Color.green);
	    //deska.drawRect(245, 245, 5, 5);
		}//if_zobrazovat
    return pp;
  }//getPriznaky()
  

 
  /**
  * metoda getVzdalenosti() z vektoru priznaku spocte vektor vzdalenosti
  * od etalonu
  * @param int pp[][] ... ukazatel na pole priznaku
  * @return int p[][] ... ukazatel na vektor vzdalenosti
  */
  public int[] getVzdalenosti(int pp[], boolean zobrazovat) {
    int i, j, priznak = 0, etalon = 0, posunuti;
    int vzd[] = new int[pocetEthalonu];
    Font    fontNormal= new Font("Helvetica", Font.BOLD, 14),
	    fontBig   = new Font("Helvetica", Font.BOLD, 18),
	    fontGigant= new Font("Helvetica", Font.BOLD, 24),
	    fontSmall = new Font("Helvetica", Font.BOLD, 10);
    for (i=0; i < pocetEthalonu; i++) vzd[i]=0;

    for (etalon = 0; etalon < pocetEthalonu; etalon++) {    
			if (zobrazovat) {
	      deska.setColor(barvaPozadi);
	      deska.fillRect(0, 0, 260, 300);
	      //deska.drawImage(img1, 0, 0, paintCanvas2);
	      deska.setColor(new Color(0, 100, 0));
	      deska.setFont(fontGigant);
	      deska.drawString("VZD\u00C1LENOSTI", 40, 26);
	      deska.setFont(fontNormal);
	      deska.setColor(Color.black);
	      deska.drawString("Porovn\u00E1me vzd\u00E1lenosti mezi vektory",0, 50);
	      deska.drawString("p\u0159\u00EDznak\u016F na\u0161\u00ED \u010D\u00EDslice a etalonu '   '",0, 68);
	      deska.setColor(Color.red);
	      deska.setFont(fontBig);
		    deska.drawString(""+etalon,220, 70);
			  //deska.drawString("pocet sloupcu, ktere segment prekryva",0, 65);
	      deska.setColor(Color.darkGray);
	      deska.setFont(fontSmall);
	      deska.drawString("p\u0159\u00EDznak",7, 86);
	      deska.drawString("\u010Dislo",10, 100);
	      deska.drawString("na\u0161e", 80, 86);
	      deska.drawString("\u010D\u00EDslice", 75, 100);
	      deska.drawString("hodnota", 133, 86);
	      deska.drawString("etalonu '"+etalon+"'", 128, 100);
	      deska.drawString("abs. rozd\u00EDl", 207, 86);
	      deska.drawString("hodnot",215, 100);
	      deska.setFont(fontBig);
	      paintCanvas2.update(paintCanvas2.getGraphics());
	      try {
				  Thread.sleep((int)(dobaCekani[2]/(1+etalon)));   
	      } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
			}//if_zobrazovat
      for (priznak = 0; priznak < pocetPriznaku; priznak++) {
        vzd[etalon] += java.lang.Math.abs(pp[priznak]-polePriznakuEthalonu[etalon][priznak]);
				if (zobrazovat) {
	        deska.setColor(Color.darkGray);
	        deska.setFont(fontBig);
	        deska.drawString((priznak+1)+"", 17, 100+20+priznak*20);
	        deska.setFont(fontSmall);
	        deska.drawString("..........", 35, 100+20+priznak*20);
	        deska.setFont(fontBig);
	        //deska.drawString((priznak+1)+"p\u0159\u00EDznak...", 10, 100+20+priznak*20);
	        deska.setColor(Color.blue);
	        deska.drawString(""+pp[priznak], 88, 100+20+priznak*20);
	        deska.drawString(""+polePriznakuEthalonu[etalon][priznak], 148, 100+20+priznak*20);
	        paintCanvas2.update(paintCanvas2.getGraphics()); 
	        try {
						Thread.sleep((int)(dobaCekani[0]/(1+etalon)));   
	        } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
	        deska.setColor(Color.black);
	        deska.setFont(fontNormal);
	        deska.drawString("I", 78,	  96+20+priznak*20);
	        deska.drawString("I", 78,	  102+20+priznak*20);
	        deska.drawString("I", 164,  96+20+priznak*20);
	        deska.drawString("I", 164,  102+20+priznak*20);
	        deska.fillRect(  113, 92+20+priznak*20, 20, 2);
	        deska.fillRect(  188, 92+20+priznak*20, 25, 2);
		      deska.drawString(">",207,  98+20+priznak*20);
	        try {
						Thread.sleep((int)(dobaCekani[0]/(1+etalon)));   
	        } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
	        paintCanvas2.update(paintCanvas2.getGraphics()); 
	        deska.setColor(Color.red);	 
	        deska.setFont(fontBig);
	        deska.drawString(""+java.lang.Math.abs(pp[priznak]-polePriznakuEthalonu[etalon][priznak]), 225, 100+20+priznak*20+1);
	        paintCanvas2.update(paintCanvas2.getGraphics());
	        try {
						Thread.sleep((int)(dobaCekani[0]/(1+etalon))*2);   
	        } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
		      //deska.drawImage( getImage(getCodeBase(), "prizn_down.gif"), 0, 250, paintCanvas2);
				}//if_zobrazovat
      }//for_priznak
			if (zobrazovat) {
	      deska.setColor(Color.black);
	      deska.drawLine(0, 252, 250, 252);
	      deska.setFont(fontNormal);
	      deska.drawString("Vzd\u00E1lenost od "+etalon+". etalonu .....", 5, 274);
	      paintCanvas2.update(paintCanvas2.getGraphics());
	      try {
					Thread.sleep((int)(dobaCekani[1]/(1+etalon)));   
	      } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
	      clipPip.play();	
	      deska.setFont(fontGigant);
	      deska.setColor(Color.red);
	      if (vzd[etalon] < 10) posunuti=0; else posunuti=-8;
	      deska.drawString(""+vzd[etalon], 225+posunuti, 275);
		    paintCanvas2.update(paintCanvas2.getGraphics());
	      try {
					Thread.sleep((int)(dobaCekani[1]/(1+etalon)));   
	      } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
	      deska.setFont(fontNormal);
	      deska.setColor(Color.black);
	      if (etalon < 9) {
	        deska.drawString("Nyni podobn\u011B pro dal\u0161\u00ED etalony.", 5, 295);
	        paintCanvas2.update(paintCanvas2.getGraphics());
	        try {
					  Thread.sleep((int)(dobaCekani[2]/(1+etalon)));   
					} catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
	      } else {
		      deska.drawString("A nyn\u00ED m\u016F\u017Eeme klasifikovat.", 5, 295);
			    paintCanvas2.update(paintCanvas2.getGraphics());
	      }
			}//if_zobrazovat	
	  }//for_etalon  
    statusBar1.setText("Vektor vzd\u00E1lenost\u00ED: ["+vzd[0]+", "+vzd[1]+
								", "+vzd[2]+", "+vzd[3]+", "+vzd[4]+", "+vzd[5]+", "+vzd[6]+
								", "+vzd[7]+", "+vzd[8]+", "+vzd[9]+"]");
    return vzd;
  }


  public int getMinimum(int vzd[]) {
    int trida = 11, etalon, min = 3*pocetEthalonu, posunuti;
    boolean jeJichVic = false;
    Font    fontNormal= new Font("Helvetica", Font.BOLD, 14),
	    fontBig   = new Font("Helvetica", Font.BOLD, 18),
	    fontGigant= new Font("Helvetica", Font.BOLD, 32),//24
	    fontHuge  = new Font("Helvetica", Font.BOLD,144),
	    fontSmall = new Font("Helvetica", Font.BOLD, 11);//10

    deska.setColor(barvaPozadi);
    deska.fillRect(0, 0, 260, 300);
    deska.setColor(new Color(0, 100, 0));
    deska.setFont(fontGigant);
    deska.drawString("V\u00DDB\u011AR MINIMA", 13, 35);//20,26
    deska.setFont(fontNormal);
    deska.setColor(Color.black);
    deska.drawString("Nejmen\u0161\u00ED vzd\u00E1lenost od etalonu", 10, 54);
    deska.drawString("znamen\u00E1 nejv\u011Bt\u0161\u00ED podobnost.",10, 69);
    deska.setColor(Color.darkGray);
    deska.setFont(fontSmall);
    deska.drawString("identifik\u00E1tor",15, 86);
    deska.drawString("t\u0159\u00EDdy",35, 100);
    deska.drawString("vzd\u00E1lenost", 105, 86);
    deska.drawString("od etalonu", 107, 100);
    //deska.drawString("hodnota", 133, 86);
    deska.setFont(fontNormal);
    paintCanvas2.update(paintCanvas2.getGraphics());
    try {  Thread.sleep(dobaCekani[2]);   
    } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
    for (etalon = 0; etalon < pocetEthalonu; etalon++) {    
      deska.setColor(Color.darkGray);
      deska.drawString(etalon+"", 44, 100+20+etalon*15);
      deska.setFont(fontSmall);
      deska.drawString("............", 70, 100+20+etalon*15);
      //deska.drawString((priznak+1)+"p\u0159\u00EDznak...", 10, 100+20+priznak*20);
      deska.setColor(Color.blue);
      deska.setFont(fontNormal);
      if (vzd[etalon] < 10) posunuti=0; else posunuti=-5;
      deska.drawString(""+vzd[etalon], 127+posunuti, 100+20+etalon*15);
      paintCanvas2.update(paintCanvas2.getGraphics()); 
      try {
      Thread.sleep(dobaCekani[0]/2);   
      } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
      
      if (vzd[etalon] <= min) 
	if (vzd[etalon] == min) 
	  jeJichVic = true;
	else {
	  min = vzd[etalon];
	  jeJichVic = false;
	  trida = etalon;
	}
    }//for(etalon)

    if (jeJichVic) {
      deska.setColor(Color.black);
      deska.setFont(fontNormal);
      //deska.drawString("Nelze rozhodnout kam za\u0159adit", 5, 295);
      deska.drawString("Je-li minimaln\u00EDch hodnot v\u00EDce", 5, 283);
      deska.drawString("nelze rozhodnout, kam za\u0159adit", 5, 298);
      paintCanvas2.update(paintCanvas2.getGraphics());
    } else {
      //deska.setFont(fontHuge);
      deska.setColor(Color.red);
      deska.drawOval(122, 107+trida*15, 16, 16);
      deska.drawOval(123, 108+trida*15, 14, 14);
      paintCanvas2.update(paintCanvas2.getGraphics());
      try {  Thread.sleep(dobaCekani[1]);   
      } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
      deska.setFont(fontNormal);
      deska.setColor(Color.black);
      deska.drawString("Nalezneme minimum vzd\u00E1lenost\u00ED", 5, 283);
      deska.drawString("("+min+") a za\u0159ad\u00EDme do t\u0159\u00EDdy '"+etaJmena[trida]+"'.", 5, 298);
      paintCanvas2.update(paintCanvas2.getGraphics());
      try {  Thread.sleep(dobaCekani[1]);   
      } catch (InterruptedException e) { play(getCodeBase(), "bad.au"); };
      deska.setFont(fontHuge);
      deska.setColor(Color.red);
      deska.drawString(""+trida, 170, 235);
      //deska.setColor(Color.green);
      //deska.drawRect(121, 105+trida*15, 3, 3);
      paintCanvas2.update(paintCanvas2.getGraphics());
    }
    return trida;
  }
}// end Class Digits
