import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.lang.*;
import java.util.*;

class Klic extends ImageButton implements MouseListener {
  Morse morse;
  AudioClip clipPip;
  Date aktCas;
  long cas1, cas2;    //Jejich rozdil je doba po kterou byl klic aktivni
  //Animator animator;
  
  public Klic(Image imgOff, Image imgOn, String label, AudioClip pip, Morse morse) {
    super(imgOff, imgOn, label);
    clipPip = pip;
    setLabel("KLI\u010C");
    addMouseListener(this);
    this.morse = morse;
  }

//  public Dimension getPreferredSize() { return new Dimension(120, 52); }
	
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mouseClicked(MouseEvent e) {}
	
  public void mousePressed(MouseEvent e) {
    int kz = morse.getKolikatyZnak();
		if (morse.aktivniOkno==2) {
	    if ((kz>0)&&(kz<10)) {
		    aktCas = new Date();
			  cas1 = aktCas.getTime();
				morse.animator = new Animator(morse);
	      morse.animator.start();
		    clipPip.loop();
			}
		} else {
			if (morse.aktivniOkno==3)
		    if ((kz>0)&&(kz<=morse.maxDelkaPismena)) {
			    aktCas = new Date();
				  cas1 = aktCas.getTime();
					morse.animator = new Animator(morse);
				  morse.animator.start();
					clipPip.loop();
				}
		}//else		
  }//end Pressed
  
  public void mouseReleased(MouseEvent e) {
    int kz = morse.getKolikatyZnak(); 
		long antialiasedTime;
		if (morse.aktivniOkno==2) {
	    if ((kz>0)&&(kz<10)) {
			  clipPip.stop();
				morse.animator.stop();
				aktCas = new Date();
		    cas2 = aktCas.getTime();
				antialiasedTime = ((int)(Math.random()*100-50)+(cas2-cas1));
				//antialiasedTime = ((int)(cas2-cas1));
				if (antialiasedTime<=0)
					antialiasedTime = 1;
	      morse.zpracujDobuTrvani(antialiasedTime);

				morse.stredniGr.setColor(Color.black);
				morse.stredniGr.setFont(new Font("Helvetica", Font.PLAIN, 10));
		    morse.stredniGr.drawString(""+(antialiasedTime), 10, 9+kz*12);

				morse.stredniGr.setColor(morse.barvaPozadi);
				morse.stredniGr.fillRect(33, kz*12-1, 200, 12);   // poradne to smaz
				morse.stredniGr.setColor(Color.green.darker());
				if (antialiasedTime>20)
					morse.stredniGr.fill3DRect(35, kz*12, (int)(antialiasedTime/10), 10, true);
				else
					morse.stredniGr.fill3DRect(35, kz*12, 2, 10, true);
			  morse.stredni.update(morse.stredni.getGraphics());
	    }
		} else {
			if (morse.aktivniOkno==3) 	
		    if ((kz>0)&&(kz<=morse.maxDelkaPismena)) {
					morse.animator.stop();
				  clipPip.stop();
					aktCas = new Date();
				  cas2 = aktCas.getTime();
					antialiasedTime = ((int)(Math.random()*100-50)+(cas2-cas1));
					morse.showStatus(""+antialiasedTime);
					if (antialiasedTime<=0)
						antialiasedTime = 1;
					morse.zpracujDobuTrvani(antialiasedTime);

					morse.stredniGr.setColor(Color.black);
					morse.stredniGr.setFont(new Font("Helvetica", Font.BOLD, 16));
			    morse.stredniGr.drawString(""+(antialiasedTime), 10, 15+kz*20);
				
					morse.stredniGr.setColor(morse.barvaPozadi);
					morse.stredniGr.fillRect(48, kz*20-1, 200, 17);   // poradne to smaz
					morse.stredniGr.setColor(Color.green.darker());
					if (antialiasedTime>20)
						morse.stredniGr.fill3DRect(50, kz*20, (int)(antialiasedTime/10), 15, true);
					else
	 					morse.stredniGr.fill3DRect(50, kz*20, 2, 15, true);
				  morse.stredni.update(morse.stredni.getGraphics());
		    }
		}		
  }//end Released
  
  public int getTrvani() {
    aktCas = new Date();
    return (int) (aktCas.getTime() - cas1);
  }
  
  /**
   * The preferred size of the button. 
   */
  public Dimension getPreferredSize() {
    if(imgOff != null) {
	  //return new Dimension(125, 62);
			return new Dimension(imgOff.getWidth(this), imgOff.getHeight(this));
    } else {
		  return new Dimension(125, 62);
    }
  }
  
}