
import java.awt.event.*;
import java.awt.*;

class Zalozky extends Panel implements MouseListener{
  Morse morse;
  
  public Zalozky(Morse mrs) {
    super();
    morse = mrs;
    addMouseListener(this);
  }  
  public Dimension	getMinimumSize() { return new Dimension(120, 360); }
  public Dimension	getPreferredSize() { return getMinimumSize(); }
  public void	update(Graphics g) { paint(g); }
  public void	paint( Graphics g) { 
    if (morse.zalozkyImg == null) {
      morse.zalozkyImg = createImage(120, 360);
      morse.zalozkyGr = morse.zalozkyImg.getGraphics();
      morse.clipBad.play();
    }
    g.drawImage(morse.zalozkyImg, 0, 0, this);
    //morse.clipPip.play();
  }
  public void mouseReleased(MouseEvent me) {
    int x, y, polozkaMenu;
    x = me.getX(); 
    y = me.getY();
		//morse.zalozkyGr.drawImage(morse.imgMenu, 0, 0, morse.zalozky);
    polozkaMenu = y/50;
    if ((x>0)&&(x<120))
      //if ((y>0)&&(y<300)) {  //z casy, kdy zalozek bylo 6, ted jsou 4
      if ((y>0)&&(y<200)) {
        morse.showStatus("Zalozka cislo: "+polozkaMenu);
				morse.zalozkyGr.drawImage(morse.imgZalozky[0][morse.aktivniOkno], 0, 50*morse.aktivniOkno, morse.zalozky);
				morse.zalozkyGr.drawImage(morse.imgZalozky[1][polozkaMenu], 0, 50*polozkaMenu, morse.zalozky);
				if ((morse.aktivniOkno==2)||(morse.aktivniOkno==3)) 
				  morse.panel3.removeAll();
					if ((morse.aktivniOkno==2)) 
					  morse.spoctiPpsti();
					 	 
				switch (polozkaMenu) {
					case 0: morse.panelGr3.setColor(morse.barvaPozadi);
					  morse.panelGr3.fillRect(0, 0, 500, 360);
			 		  morse.panelGr3.setColor(Color.black);
					  //morse.panelGr3.drawString("Welcome", 100, 100);
					  morse.panelGr3.drawImage(morse.imgUvod, 0, 0, morse.panel3);
					  morse.panel3.update(morse.panel3.getGraphics());
						morse.clipUvod.play();
	          break;
					case 1: morse.panelGr3.setColor(morse.barvaPozadi);
					  morse.panelGr3.fillRect(0, 0, 500, 360);
				    morse.panelGr3.setFont(new Font("Helvetica", Font.BOLD, 30));
				    morse.panelGr3.setColor(new Color(0, 100, 0));
				    morse.panelGr3.drawString("INFORMACE O PROGRAMU", 50, 60);
				    morse.panelGr3.setFont(new Font("Helvetica", Font.BOLD, 16));
				    morse.panelGr3.setColor(Color.black);
				    morse.panelGr3.drawString("Program je zam\u00FD\u0161len jako demonstrace jedn\u00E9 ze z\u00E1kladn\u00EDch", 20, 100);
				    morse.panelGr3.drawString("p\u0159\u00EDznakov\u00FDch metod klasifikace - krit\u00E9ria minim\u00E1ln\u00ED chyby. ", 20, 118);
				    morse.panelGr3.drawString("Poznamenejme, \u017Ee tato metoda je tak\u00E9 zn\u00E1ma jako Bayes\u016Fv", 20, 136);
				    morse.panelGr3.drawString("klasifik\u00E1tor.", 20, 154);
//				    morse.panelGr3.drawString("  Pred vlastni klasifikaci je treba klasifikator natrenovat.", 20, 180);
//				    morse.panelGr3.drawString("Proto se nejprve prepnete do sekce TRENOVANI.", 20, 118);
				    morse.panelGr3.drawString("Po spu\u0161t\u011Bn\u00ED je klasifik\u00E1tor natr\u00E9nov\u00E1n autory. Ti v\u0161ak nejsou", 20, 180);
				    morse.panelGr3.drawString("v Morseov\u011B abeced\u011B p\u0159\u00EDli\u0161 zb\u011Bhl\u00ED, a tak vys\u00EDlaj\u00ED velmi pomalu.", 20, 198);
				    morse.panelGr3.drawString("Proto V\u00E1m sou\u010Dasn\u00E9 nastaven\u00ED klasifik\u00E1toru pravd\u011Bpodobn\u011B", 20, 216);
				    morse.panelGr3.drawString("nebude vyhovovat. V sekci TR\u00C9NOV\u00C1N\u00CD m\u016F\u017Eete klasifik\u00E1tor", 20, 234);
				    morse.panelGr3.drawString("natr\u00E9novat na svoji rychlost vys\u00EDl\u00E1n\u00ED.", 20, 252);
				    morse.panelGr3.drawString("M\u00E1te-li klasifik\u00E1tor natr\u00E9nov\u00E1n, m\u016F\u017Eete vyzkou\u0161et vlastn\u00ED ", 20, 278);
				    morse.panelGr3.drawString("rozpozn\u00E1v\u00E1n\u00ED v sekci KLASIFIKACE.", 20, 296);
				    morse.panelGr3.drawString("Nyn\u00ED V\u00E1m p\u0159ejeme p\u0159\u00EDjemnou z\u00E1bavu a pou\u010Den\u00ED.", 20, 322);
				    morse.panelGr3.drawString("Auto\u0159i", 400, 340);
						

					  morse.panel3.update(morse.panel3.getGraphics());
						morse.clipNavod.play();
					  break;
				  case 2: morse.panel3.removeAll();
					  morse.panel3.setLayout(new BorderLayout(0, 0));
					  morse.panel3.add(morse.stredni, "Center");
					  morse.panel3.add(morse.severni, "North");
					  morse.panel3.add(morse.jizni, "South");
					  morse.panel3.add(morse.zapadni, "West");
					  morse.panel3.add(morse.vychodni, "East");
					  morse.panel3.doLayout();
						morse.jizni.removeAll();
						if (morse.kolikatyTrenink >= morse.minPocetTreninku)
							morse.jizni.add(morse.bPodrobnosti);
						morse.jizni.validate();
//						morse.jizni.doLayout();
					  morse.zapadni.doLayout();
						morse.vychodni.add(morse.bTrenovat);
						morse.vychodni.doLayout();
						morse.severniGr.setColor(morse.barvaPozadi);
						morse.severniGr.fillRect(0, 0, 500, 180);
						morse.severniGr.drawImage(morse.imgTren, 0, 0, morse.severni);
						morse.zapadniGr.setColor(morse.barvaPozadi);
						morse.zapadniGr.fillRect(0, 0, 150, 120);
						morse.vychodniGr.setColor(morse.barvaPozadi);
						morse.vychodniGr.fillRect(0, 0, 200, 120);
						morse.vychodni.repaint();
						morse.vykresliProgresBar(morse.kolikatyTrenink);
						morse.stredniGr.setColor(morse.barvaPozadi);
						morse.stredniGr.fillRect(0, 0, 150, 120);
						morse.stredni.repaint();
						morse.jizniGr.setColor(morse.barvaPozadi);
						morse.jizniGr.fillRect(0, 0, 500, 60);
						morse.jizniGr.setColor(Color.black);
						morse.jizniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
						if (morse.kolikatyTrenink >= morse.minPocetTreninku)
							morse.jizniGr.drawString("Je dostate\u010Dn\u011B natr\u00E9nov\u00E1no.", 20, 40);
						else
							morse.jizniGr.drawString("Nen\u00ED dostate\u010Dn\u011B natr\u00E9nov\u00E1no.", 20, 40);
						morse.jizni.repaint();
						morse.konecTrenovani = true;
						morse.trener = null;
						
						morse.severniGr.setColor(morse.barvaPozadi);
					  morse.severniGr.fillRect(0, 0, 500, 180);
				    morse.severniGr.setFont(new Font("Helvetica", Font.BOLD, 40));
				    morse.severniGr.setColor(new Color(0, 100, 0));
				    morse.severniGr.drawString("TR\u00C9NOV\u00C1N\u00CD", 100, 60);
				    morse.severniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
				    morse.severniGr.setColor(Color.black);
				    morse.severniGr.drawString("Klasifik\u00E1tor tr\u00E9nujeme sign\u00E1lem SOS takto:", 20, 85);
				    morse.severniGr.drawString("1) Klikn\u011Bte na tla\u010D\u00EDtko nahr\u00E1v\u00E1n\u00ED", 30, 105);
				    morse.severniGr.drawString("2) Stiskn\u011Bte KL\u00CD\u010C t\u0159ikr\u00E1t kr\u00E1tce, t\u0159ikr\u00E1t dlouze a op\u011Bt t\u0159ikr\u00E1t kr\u00E1tce", 30, 121);
				    morse.severniGr.drawString("3) Zopakujte body 1) a 2) alespo\u0148 p\u011btkr\u00E1t, l\u00E9pe v\u0161ak desetkr\u00E1t", 30, 137);
				    morse.severniGr.drawString("Zaj\u00EDmaj\u00ED-li V\u00E1s detaily pr\u00E1ce klasifik\u00E1toru, nezapome\u0148te", 20, 159);
				    morse.severniGr.drawString("po natr\u00E9nov\u00E1n\u00ED stisknout tla\u010D\u00EDtko PODROBNOSTI.", 20, 175);
					  morse.severni.update(morse.severni.getGraphics());

						morse.clipTrenovani.play();
					  break;
				  case 3: morse.panel3.removeAll();
					  morse.panel3.setLayout(new BorderLayout(0, 0));
					  morse.panel3.add(morse.stredni, "Center");
					  morse.panel3.add(morse.severni, "North");
					  morse.panel3.add(morse.jizni, "South");
					  morse.panel3.add(morse.zapadni, "West");
					  morse.panel3.add(morse.vychodni, "East");
						morse.doLayout();
					  morse.panel3.doLayout();
					  morse.zapadni.doLayout();
						morse.vychodni.removeAll();
						morse.vychodni.doLayout();
						morse.jizni.removeAll();
						if (morse.kolikatyTrenink >= morse.minPocetTreninku)
							morse.jizni.add(morse.bPodrobnosti);
						morse.jizni.doLayout();
						morse.vychodniGr.setColor(morse.barvaPozadi);
						morse.vychodniGr.fillRect(0, 0, 200, 120);
						morse.vychodniGr.setColor(Color.black);
						morse.vychodniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
						morse.vychodniGr.drawString("Zde je m\u00EDsto pro", 20, 30);
						morse.vychodniGr.drawString("v\u00FDpis rozpoznan\u00FDch", 20, 45);
						morse.vychodniGr.drawString("zna\u010Dek a p\u00EDsmen.", 20, 60);
						
						morse.severniGr.setColor(morse.barvaPozadi);
						morse.severniGr.fillRect(0, 0, 500, 180);
						morse.severniGr.drawImage(morse.imgKlas, 0, 0, morse.severni);
						morse.zapadniGr.setColor(morse.barvaPozadi);
						morse.zapadniGr.fillRect(0, 0, 150, 120);
						morse.stredniGr.setColor(morse.barvaPozadi);
						morse.stredniGr.fillRect(0, 0, 150, 120);
						morse.jizniGr.setColor(morse.barvaPozadi);
						morse.jizniGr.fillRect(0, 0, 500, 60);
						morse.jizni.repaint();
						morse.vychodni.repaint();
						morse.stredni.repaint();
						morse.zapadni.repaint();						
						morse.severni.repaint();						
						
						morse.severniGr.setColor(morse.barvaPozadi);
					  morse.severniGr.fillRect(0, 0, 500, 180);
				    morse.severniGr.setFont(new Font("Helvetica", Font.BOLD, 40));
				    morse.severniGr.setColor(new Color(0, 100, 0));
				    morse.severniGr.drawString("KLASIFIKACE", 100, 60);
				    morse.severniGr.setFont(new Font("Helvetica", Font.BOLD, 14));
				    morse.severniGr.setColor(Color.black);
				    morse.severniGr.drawString("Podobn\u011B jako p\u0159i tr\u00E9nov\u00E1n\u00ED vy\u0161lete libovoln\u00E9 p\u00EDsmeno Morseovy", 20, 89);
				    morse.severniGr.drawString("abecedy a pod\u00EDvejte se, jak Bayes\u016Fv klasifik\u00E1tor pracuje. Detaily", 20, 105);
				    morse.severniGr.drawString("se dozv\u00EDte op\u011Bt pomoc\u00ED tla\u010D\u00EDtka PODROBNOSTI vpravo dole.", 20, 121);
				    morse.severniGr.drawString("Pokud klasifik\u00E1tor nerozpozn\u00E1v\u00E1 spr\u00E1vn\u011B, je to zp\u016Fsobeno nedo-", 20, 143);
				    morse.severniGr.drawString("state\u010Dn\u00FDm natr\u00E9nov\u00E1n\u00EDm. V takov\u00E9m p\u0159\u00EDpad\u011B doporu\u010Dujeme natr\u00E9-", 20, 159);
				    morse.severniGr.drawString("novat klasifik\u00E1tor v sekci TR\u00C9NOV\u00C1N\u00CD. ", 20, 175);
					  morse.severni.update(morse.severni.getGraphics());
						morse.clipKlasifikace.play();
						morse.kolikatyZnak = 0;
					  break;
						/*
				  case 4: morse.panel3.removeAll();
					  morse.panelGr3.setColor(morse.barvaPozadi);
					  morse.panelGr3.fillRect(0, 0, 500, 360);
					  //add komponenty
					  morse.panel3.doLayout();
					  morse.panelGr3.setColor(Color.black);
					  morse.panelGr3.drawString("Options", 200, 30);
					  morse.panel3.repaint();
					  break;
				  case 5: morse.panel3.removeAll();
					  morse.panelGr3.setColor(morse.barvaPozadi);
					  morse.panelGr3.fillRect(0, 0, 500, 360);
					  morse.panel3.doLayout();
					  morse.panelGr3.setColor(Color.black);
					  morse.panelGr3.drawString("Zde bude morseovka", 200, 30);
					  morse.panel3.repaint();
					  break;
						*/
				}//end switch
			morse.doLayout();
			morse.zalozky.repaint();
			morse.aktivniOkno = polozkaMenu;

      }	
  }
  public void mouseEntered(MouseEvent me) {}
  public void mouseExited(MouseEvent me) {}
  public void mousePressed(MouseEvent me) {}
  public void mouseClicked(MouseEvent me) {}
}//end class Zalozky 
